﻿<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8"/>
    <title>Race State API</title>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css"
          integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">
</head>

<body>
<div class="d-none" id="userInfo">
    <p class="text-center">Учетная запись: <span id="userName"></span></p>
    <div class="row">
        <div class="col text-center">
            <input class="btn btn-primary m-1" type="button" value="Выйти" id="logOut"/>
        </div>
    </div>
</div>

<form class="offset-4 col-4" id="loginForm">
    <h4 class="text-center">Авторизация</h4>
    <input class="form-control m-1" type="email" id="emailLogin" placeholder="Введите логин"/>
    <input class="form-control m-1" type="password" id="passwordLogin" placeholder="Введите пароль"/>
    <div class="row">
        <div class="col text-center">
            <input class="btn btn-primary m-1" type="submit" id="submitLogin" value="Войти"/>
        </div>
    </div>
</form>

<div>
    <table class="d-none" id="crudRace">
        <tr>
            <th class="text-center">Пункт вылета</th>
            <th class="text-center">Пункт назначения</th>
            <th class="text-center">Время вылета</th>
            <th class="text-center">Время прилета</th>
            <th class="text-center">Задержка в мин.</th>
            <th class="text-center">Действие</th>
        </tr>
        <tr id="createRace">
            <td><input class="form-control createRaceInput" type="text" id="fromCity" placeholder="Пункт вылета"></td>
            <td><input class="form-control createRaceInput" type="text" id="toCity" placeholder="Пункт прилета"></td>
            <td><input class="form-control createRaceInput" type="datetime-local" id="outTime"></td>
            <td><input class="form-control createRaceInput" type="datetime-local" id="inTime"></td>
            <td><input class="form-control createRaceInput" type="number" id="delayMinutes" value="0"></td>
            <td>
                <input class="btn btn-primary" id="raceSubmit" type="submit" value="Добавить">
                <input class="btn btn-primary mr-1 mb-1 d-none" id="raceUpdateSubmit" raceId="" onclick="updateRace()"
                       type="submit"
                       value="Изменить">
                <input class="btn btn-primary mr-1 d-none" id="raceDeleteSubmit" raceId="" onclick="deleteRace()"
                       type="submit"
                       value="Удалить">
            </td>
        </tr>
    </table>
</div>

<div>
    <table class="table" id="mainTable">
    </table>
</div>

<script>
    let tokenKey = null;
    sessionStorage.clear(tokenKey);
    
    window.onload = function () {
        getData("/api/race");
    }
    
    async function getTokenAsync() {
        const formData = new FormData();
        formData.append("grant_type", "password");
        formData.append("username", document.getElementById("emailLogin").value);
        formData.append("password", document.getElementById("passwordLogin").value);

        const response = await fetch("/token", {
            method: "POST",
            headers: {"Accept": "application/json"},
            body: formData
        });

        const data = await response.json();

        if (response.ok === true) {
            document.getElementById("userName").innerText = data.username;
            document.getElementById("userInfo").className = "offset-4 col-4";
            document.getElementById("loginForm").className = "d-none";
            document.getElementById("crudRace").className = "table";
            showEditButton();
            sessionStorage.setItem(tokenKey, data.access_token);
        } else {
            console.log("Error: ", response.status, data.errorText);
        }
    }

    async function getData(url) {
        const token = sessionStorage.getItem(tokenKey);

        const response = await fetch(url, {
            method: "GET",
            headers: {
                "Accept": "application/json",
                "Authorization": "Bearer " + token
            }
        });
        if (response.ok === true) {
            const data = await response.json();
            buildTable(data);

            function buildTable(data) {
                var table = document.getElementById('mainTable');
                table.innerHTML = null;
                table.innerHTML += `<tr>
                                        <th class="text-center">Пункт вылета</th>
                                        <th class="text-center">Пункт назначения</th>
                                        <th class="text-center">Время вылета</th>
                                        <th class="text-center">Время прилета</th>
                                        <th class="text-center">Статус</th>
                                    </tr>`;
                if (data.length === 0) {
                    table.innerHTML = `<td><p class="text-center text-danger">Список авиарейсов пуст</p></td>`
                } else {
                    for (var i = 0; i < data.length; i++) {
                        var state = `<td><p class="text-center text-success">Ontime</p></td>`;
                        if (data[i].delayMinutes > 0) {
                            state = `<td><p class="text-center text-danger">Delayed for ${data[i].delayMinutes} min.</p></td>`;
                        }
                        var row = `<tr>
                                    <td><input class="form-control" disabled value="${data[i].fromCity}"></td>
                                    <td><input class="form-control" disabled value="${data[i].toCity}"</td>
                                    <td><input class="form-control" type="datetime-local" disabled value="${data[i].outTime}"</td>
                                    <td><input class="form-control" type="datetime-local" disabled value="${data[i].inTime}"</td>
                                    ${state}
                                    <td><input class="edit-btn form-control btn btn-primary" hidden onclick="getRace(this)" idRace="${data[i].id}" value="Изменить"></td>
                                </tr>`;
                        table.innerHTML += row;
                    }
                }
            }
        } else
            console.log("Status: ", response.status);
        if (sessionStorage.getItem(tokenKey) !== null) {
            showEditButton();
        }
    }

    document.getElementById("submitLogin").addEventListener("click", e => {
        e.preventDefault();
        getTokenAsync();
    });

    document.getElementById("logOut").addEventListener("click", e => {
        e.preventDefault();
        document.getElementById("userName").innerText = "";
        document.getElementById("emailLogin").value = '';
        document.getElementById("passwordLogin").value = '';
        document.getElementById("userInfo").className = "d-none";
        document.getElementById("crudRace").className = "d-none";
        document.getElementById("loginForm").className = "offset-4 col-4";
        if (sessionStorage.getItem(tokenKey) !== null) {
            let hiddens = document.getElementsByClassName("edit-btn");
            for (i = 0; i < hiddens.length; i++) {
                hiddens[i].hidden = true;
            }
        }
        sessionStorage.clear(tokenKey);
    });

    document.getElementById("raceSubmit").addEventListener("click", e => {
        e.preventDefault();
        postData("/api/race");
    });

    async function postData(url) {
        const token = sessionStorage.getItem(tokenKey);
        const obj = {};
        document.querySelectorAll('.createRaceInput').forEach(el => obj[el.id] = el.value);

        const json = JSON.stringify(obj, null, ' ');
        await fetch(url, {
            method: 'POST',
            headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
                "Authorization": "Bearer " + token
            },
            body: json,
        });

        setInputsNull();
        await getData("/api/race");
    }

    async function getRace(el) {
        const idRace = el.getAttribute("idRace")
        const token = sessionStorage.getItem(tokenKey);

        const url = "api/race/" + idRace;
        const response = await fetch(url, {
            method: 'GET',
            headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
                "Authorization": "Bearer " + token
            },
        });
        if (response.ok === true) {
            const data = await response.json();
            document.getElementById("raceUpdateSubmit").setAttribute("raceId", idRace);
            document.getElementById("raceDeleteSubmit").setAttribute("raceId", idRace);
            document.getElementById("raceSubmit").className = "d-none";
            document.getElementById("raceUpdateSubmit").className = "btn btn-primary mr-1 mb-1";
            document.getElementById("raceDeleteSubmit").className = "btn btn-primary mr-1";
            document.getElementById("crudRace").className = "table";
            document.getElementById("mainTable").className = "d-none";
            document.getElementById("fromCity").value = data.fromCity;
            document.getElementById("toCity").value = data.toCity;
            document.getElementById("outTime").value = data.outTime;
            document.getElementById("inTime").value = data.inTime;
            document.getElementById("delayMinutes").value = data.delayMinutes;
            await getData("/api/race")
        }
    }

    async function updateRace() {
        const token = sessionStorage.getItem(tokenKey);
        const obj = {};
        document.querySelectorAll('.createRaceInput').forEach(el => obj[el.id] = el.value);
        obj["id"] = document.getElementById('raceUpdateSubmit').getAttribute(`raceId`);
        const json = JSON.stringify(obj, null, ' ');
        await fetch("api/race", {
            method: 'PUT',
            headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
                "Authorization": "Bearer " + token
            },
            body: json,
        });
        showHideActionButtons();
        setInputsNull();
        await getData("/api/race");
    }

    async function deleteRace() {
        const token = sessionStorage.getItem(tokenKey);
        const idRace = document.getElementById('raceDeleteSubmit').getAttribute(`raceId`);

        await fetch("api/race/" + idRace, {
            method: 'DELETE',
            headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
                "Authorization": "Bearer " + token
            },
        });
        showHideActionButtons();
        setInputsNull();
        await getData("/api/race");
    }

    function setInputsNull() {
        document.getElementById("fromCity").value = null;
        document.getElementById("toCity").value = null;
        document.getElementById("outTime").value = null;
        document.getElementById("inTime").value = null;
        document.getElementById("delayMinutes").value = 0;
    }

    function showEditButton() {
        let hiddens = document.getElementsByClassName("edit-btn");
        for (i = 0; i < hiddens.length; i++) {
            hiddens[i].removeAttribute("hidden")
        }
    }
    
    function showHideActionButtons(){
        document.getElementById("mainTable").className = "table";
        document.getElementById("raceSubmit").className = "btn btn-primary";
        document.getElementById("raceUpdateSubmit").className = "d-none";
        document.getElementById("raceDeleteSubmit").className = "d-none";
    }
</script>
</body>
